Redmine - Defect #33339

Broken layout of the preview tab of "Welcome text" setting due to unexpectedly applied padding-left
2020-04-22 12:10 - Go MAEDA

Status: Closed Start date:

Priority: Normal Due date:

Assignee: Go MAEDA % Done: 0%
Category: Administration Estimated time: 0.00 hour
Target version: 41.2

Resolution: Fixed Affected version: 4.0.7
Description

See the screenshots below. The preview tab has unwanted extra margin on the left side.

Edit:
welcome-text-edit.png

Preview:
welcome-text-preview.png

Related issues:
Related to Redmine - Patch #33453: Add plugin CSS classes to plugin settings ... Closed

Associated revisions

Revision 19720 - 2020-04-23 17:33 - Go MAEDA
Broken layout of the preview tab of "Welcome text" setting due to unexpectedly applied padding-left (#33339).

Patch by Bernhard Rohloff.

Revision 19721 - 2020-04-23 17:35 - Go MAEDA
Merged r19720 from trunk to 4.1-stable (#33339).

Revision 19729 - 2020-04-28 03:23 - Go MAEDA

Fix Ul issues in the setting page of some plugins that have arisen after r19720.

Patch by Marius BALTEANU.

Revision 19730 - 2020-04-28 03:26 - Go MAEDA
Merged r19729 from trunk to 4.1-stable (#33339).

History

#1 - 2020-04-23 08:55 - Yuichi HARADA

The reason the preview looks like this is because the CSS style ".tabular.settings adding-left: 300px; }" is working.
I think the following patch will solve the problem.

diff --git a/public/stylesheets/application.css b/public/stylesheets/application.css
index a7512bd48..26606f4bc 100644
--— a/public/stylesheets/application.css
+++ b/public/stylesheets/application.css
@@ -847,7 +847,7 @@ input#months { width: 46px; }
.tabular.settings .wiki-preview, .tabular.settings .JjstTabs { width: 99%; }
.tabular .wiki-preview p {
min-height: initial;
- padding: 0;
+ padding: 0 !important;
padding-top: lem !important;
padding-bottom: lem !important;
overflow: initial;

#2 - 2020-04-23 10:18 - Bernhard Rohloff
https://www.redmine.org/projects/redmine/repository/entry/trunk/public/stylesheets/application.css#L856

Yuichi HARADA wrote:

The reason the preview looks like this is because the CSS style ".tabular.settings p{ padding-left: 300px; }" is working.

| think the following patch will solve the problem.

(-]

As this padding can lead to further issues in other parts | would prefer to constrain it to only the direct children of the tabular settings container. I'm
also not a huge fan of the limportant statement and try to avoid it.

Index: public/stylesheets/application.css

-—— public/stylesheets/application.css (Revision 19718)
+++ public/stylesheets/application.css (Arbeitskopie)
@@ -853,7 +853,7 @@

overflow: initial;

}
—.tabular.settings p{ padding-left: 300px; }
+.tabular.settings > p{ padding-left: 300px; }

.tabular.settings label{ margin-left: -300px; width: 295px; }
.tabular.settings textarea, .tabular.settings .wiki-preview, .tabular.settings .jstTabs { width: 99%; }

#3 - 2020-04-23 10:35 - Yuichi HARADA
Bernhard Rohloff wrote:

As this padding can lead to further issues in other parts | would prefer to constrain it to only the direct children of the tabular settings container.
I'm also not a huge fan of the limportant statement and try to avoid it.

(-]

Thanks for pointing out. | think your patch is better. | think too it's correct not to use "limportant" whenever possible.

#4 - 2020-04-23 10:42 - Go MAEDA

- Target version set to 4.1.2

Setting the target version to 4.1.2.

#5 - 2020-04-23 17:36 - Go MAEDA

- Subject changed from The layout of the preview tab of "Welcome text" is broken to Broken layout of the preview tab of “Welcome text” setting due to
unexpectedly applied padding-left

- Status changed from New to Closed
- Assignee set to Go MAEDA

- Resolution set to Fixed

Committed the patch. Thank you for fixing the issue.

#6 - 2020-04-24 04:03 - Go MAEDA

- Subject changed from Broken layout of the preview tab of “Welcome text” setting due to unexpectedly applied padding-left to Broken layout of the
preview tab of "Welcome text" setting due to unexpectedly applied padding-left

#7 - 2020-04-26 13:14 - Alexander Meindl

Hi,

r19720 breaks alignment with lots of plugin settings, because this padding left is used in plugin.html.erb
If a plugin uses tabs for settings, this looks shifted to the left.

#8 - 2020-04-26 15:04 - Bernhard Rohloff

Alexander Meindl wrote:

Hi,
https://www.redmine.org/projects/redmine/repository/entry/trunk/public/stylesheets/application.css#L856
https://www.redmine.org/projects/redmine/repository/svn/revisions/19720
www.redmine.org/projects/redmine/repository/entry/trunk/app/views/settings/plugin.html.erb

r19720 breaks alignment with lots of plugin settings, because this padding left is used in plugin.html.erb

If a plugin uses tabs for settings, this looks shifted to the left.

Do you have any example such a plugin, so we can look for a proper fix for the padding issues. The whole CSS styles for the padding inside these
boxes look a bit chaotic to me.

#9 - 2020-04-26 15:22 - Alexander Meindl

- File redminecrm_settings.png added

Hi,

sure, e.g. redmineup CRM settings. See my attachment.
redminecrm_settings.png

#10 - 2020-04-26 15:28 - Go MAEDA

- Status changed from Closed to Reopened

#11 - 2020-04-26 15:33 - Go MAEDA
- File sample-plugin.png added
Alexander Meindl wrote:

sure, e.g. redmineup CRM settings. See my attachment.

To my eyes, it appears to be normal. And | could not find any problem with the sample plugin (/extra/sample_plugin). Could you describe more detail?
sample-plugin.png

#12 - 2020-04-26 15:35 - Alexander Meindl

The problem only exist, if tabs are used in settings, e.g. with most of redmineup plugins.
#13 - 2020-04-26 16:01 - Go MAEDA
Alexander Meindl wrote:
The problem only exist, if tabs are used in settings, e.g. with most of redmineup plugins.

If the problem is specific to particular third-party plugins, it should be cared by the third-party vendor. Maybe the cause of the problem is the enhanced
Ul of the plugins. | recommend you to contact the vendor.

#14 - 2020-04-26 16:10 - Alexander MeindlI
Are there any non third-party Plugins?

At the moment in template plugin.html.erb is set
<div class="box tabular settings">

The related css code is used by plugins. If css code changes in Redmine, all plugin developers have to take care of this change. But if you think this
is the best solution, this should not be a problem.

#15 - 2020-04-26 16:36 - Go MAEDA

Alexander Meindl wrote:
The related css code is used by plugins. If css code changes in Redmine, all plugin developers have to take care of this change. But if you think
this is the best solution, this should not be a problem.

| checked two plugins that | use (redmine_issue_templates and redmine-view-customize) and those plugins are not affected. | think the problem is

specific to particular plugins that enhance the setting page.

And | could not find any problem in the screenshot
https://www.redmine.org/projects/redmine/repository/svn/revisions/19720
www.redmine.org/projects/redmine/repository/entry/trunk/app/views/settings/plugin.html.erb

redminecrm_settings.png. Could you describe what is the problem?
#16 - 2020-04-26 17:06 - Alexander Meindl

The labels of the settings are cut. There should be more space for it and moved to the right. On the picture the forth settings from top and the second
last entry are not complete. Can you see it?

#17 - 2020-04-26 17:12 - Alexander Meindl
- File helpdesk.png added

| attached another example screen with incorrect label lenght.

#18 - 2020-04-26 18:14 - Marius BALTEANU

Let's use for now this safer fix:

mariusbalteanu@Mariuss—-MacBook-Pro redmine % git diff

diff --git a/public/stylesheets/application.css b/public/stylesheets/application.css
index 922bebeb9..330b1d486 100644

—-—— a/public/stylesheets/application.css

+++ b/public/stylesheets/application.css

@@ -847,6 +847,7 @@ input#months { width: 46px; }

.tabular .wiki-preview, .tabular .jstTabs {width: 95%;}
.tabular.settings .wiki-preview, .tabular.settings .JjstTabs { width: 99%; }
+.tabular.settings .wiki-preview p {padding-left: 0 !important}
.tabular .wiki-preview p {
min-height: initial;
padding: 0;
@@ -855,7 +856,7 @@ input#months { width: 46px; }
overflow: initial;

}
—.tabular.settings > p{ padding-left: 300px; }
+.tabular.settings p { padding-left: 300px; }

.tabular.settings label{ margin-left: -300px; width: 295px; }
.tabular.settings textarea, .tabular.settings .wiki-preview, .tabular.settings .JjstTabs { width: 99%; }

#19 - 2020-04-27 03:26 - Go MAEDA

- Assignee changed from Go MAEDA to Jean-Philippe Lang

I am not sure if it is the right way to change the code of Redmine in order to fix RedmineUP plugins.
| will leave the judgment to Jean-Philippe Lang.

#20 - 2020-04-27 06:38 - Alexander Meindl

- File settings _patch_with_plugin_classes.patch added

Hi Go MAEDA,

| would suggest, that we stick to your solution. But it should be a possibility for plugin developers to change css for an individual namespace to the
plugin settings (without using deface or Javascript).

If a css class would be added with the plugin name, a plugin developer can change css for the required plugin.

| added a patch for this possible change. It would be very helpful, also for other situations for a Redmine plugin developer.

#21 - 2020-04-27 07:41 - Go MAEDA

Alexander Meindl wrote:

| added a patch for this possible change. It would be very helpful, also for other situations for a Redmine plugin developer.

Thank you for sharing the patch. It would be nice if the patch will be a part of the next major release. Could you open a new issue for this feature?

#22 - 2020-04-27 08:21 - Marius BALTEANU

Go Maeda, why we don't revert the change committed and apply to safer fix which targets only the p element from settings wiki-preview?

#23 - 2020-04-27 11:14 - Bernhard Rohloff
Marius BALTEANU wrote:
Go Maeda, why we don't revert the change committed and apply to safer fix which targets only the p element from settings wiki-preview?

Since the current fix really seems to affect existing plugins | tend to go with Marius on this topic. It would be unfortunate to break existing plugins with
a support release like v4.1.2.

The markup and CSS styles for forms are quite messy with multiple selectors, negative padding, no semantic structure. Perhaps it's better to clean
this whole thing up in a future major release.

#24 - 2020-04-27 11:17 - Marius BALTEANU
Bernhard Rohloff wrote:
Marius BALTEANU wrote:
Go Maeda, why we don't revert the change committed and apply to safer fix which targets only the p element from settings wiki-preview?
Since the current fix really seems to affect existing plugins | tend to go with Marius on this topic. It would be unfortunate to break existing plugins
with a support release like v4.1.2.

The markup and CSS styles for forms are quite messy with multiple selectors, negative padding, no semantic structure. Perhaps it's better to
clean this whole thing up in a future major release.

Totally agree with your remarks.

#25 - 2020-04-27 11:38 - Go MAEDA
- Assignee changed from Jean-Philippe Lang to Go MAEDA
Bernhard Rohloff wrote:

Since the current fix really seems to affect existing plugins | tend to go with Marius on this topic.

Do you know if there are any affected plugins other than RedmineUP's ones? If so, | will readily follow Marius' suggestion in #33339#note-18.

The reason | have been hesitating to commit the fix is that | am afraid of changing the code of Redmine just for fixing plugins from a particular
third-party vendor. However, if plugins other than ones from RedmineUP are also affected, it's a different story.

#26 - 2020-04-27 12:19 - Mischa The Evil
Go MAEDA wrote:
[.]

The reason | have been hesitating to commit the fix is that | am afraid of changing the code of Redmine just for fixing plugins from a particular
third-party vendor. However, if plugins other than ones from RedmineUP are also affected, it's a different story.

As far as | can see any plugin that has one or more text_area type setting and/or long settings labels will be affected like the RedmineUP example
given by Alexander Meindl.

| think that the fix proposed by Marius in #note-18 is the proper one (for now).

#27 - 2020-04-28 03:28 - Go MAEDA

- Status changed from Reopened to Closed

Committed the fix #33339#note-18.

Thank you all for your advice.

#28 - 2020-05-16 08:10 - Mischa The Evil
- Related to Patch #33453: Add plugin CSS classes to plugin settings views added

Files

welcome-text-edit.png 29.6 KB 2020-04-22 Go MAEDA
welcome-text-preview.png 21.3 KB 2020-04-22 Go MAEDA
redminecrm_settings.png 175 KB 2020-04-26 Alexander Meind|
sample-plugin.png 18.2 KB 2020-04-26 Go MAEDA
helpdesk.png 117 KB 2020-04-26 Alexander Meindl
settings_patch_with_plugin_classes.patch 548 Bytes 2020-04-27 Alexander Meind|
